(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var Symbol = Package['ecmascript-runtime-server'].Symbol;
var Map = Package['ecmascript-runtime-server'].Map;
var Set = Package['ecmascript-runtime-server'].Set;

/* Package-scope variables */
var SandstormPowerbox;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                                  //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                               //
                                                                                                                      //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 // 1
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                              // 2
// All rights reserved.                                                                                               // 3
//                                                                                                                    // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                    // 5
// you may not use this file except in compliance with the License.                                                   // 6
// You may obtain a copy of the License at                                                                            // 7
//                                                                                                                    // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       // 9
//                                                                                                                    // 10
// Unless required by applicable law or agreed to in writing, software                                                // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                  // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           // 13
// See the License for the specific language governing permissions and                                                // 14
// limitations under the License.                                                                                     // 15
var Crypto = Npm.require("crypto");                                                                                   // 17
                                                                                                                      //
var Capnp = Npm.require("capnp");                                                                                     // 18
                                                                                                                      //
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                        // 19
var Grain = Capnp.importSystem("sandstorm/grain.capnp"); // TODO(cleanup): lift this out of a package so it can share with async-helpers.js
                                                                                                                      //
var Future = Npm.require("fibers/future");                                                                            // 23
                                                                                                                      //
var promiseToFuture = function (promise) {                                                                            // 24
  var result = new Future();                                                                                          // 25
  promise.then(result.return.bind(result), result.throw.bind(result));                                                // 26
  return result;                                                                                                      // 27
};                                                                                                                    // 28
                                                                                                                      //
var waitPromise = function (promise) {                                                                                // 30
  return promiseToFuture(promise).wait();                                                                             // 31
};                                                                                                                    // 32
                                                                                                                      //
function encodePowerboxDescriptor(desc) {                                                                             // 34
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                                     // 39
                                                                                                                      //
Meteor.methods({                                                                                                      // 41
  newFrontendRef: function (sessionId, frontendRefRequest) {                                                          // 42
    // Completes a powerbox request for a frontendRef capability.                                                     // 43
    check(sessionId, String); // frontendRefRequest is type-checked by frontendRefRegistry.validate(), below.         // 44
                                                                                                                      //
    var db = this.connection.sandstormDb;                                                                             // 47
    var frontendRefRegistry = this.connection.frontendRefRegistry;                                                    // 48
    var session = db.collections.sessions.findOne({                                                                   // 50
      _id: sessionId,                                                                                                 // 51
      userId: this.userId || {                                                                                        // 51
        $exists: false                                                                                                // 51
      }                                                                                                               // 51
    });                                                                                                               // 51
                                                                                                                      //
    if (!session) {                                                                                                   // 52
      throw new Meteor.Error(403, "Invalid session ID");                                                              // 53
    }                                                                                                                 // 54
                                                                                                                      //
    var _frontendRefRegistry$ = frontendRefRegistry.validate(db, session, frontendRefRequest),                        // 42
        descriptor = _frontendRefRegistry$.descriptor,                                                                // 42
        requirements = _frontendRefRegistry$.requirements,                                                            // 42
        frontendRef = _frontendRefRegistry$.frontendRef;                                                              // 42
                                                                                                                      //
    descriptor = encodePowerboxDescriptor(descriptor);                                                                // 58
    var grainId = session.grainId;                                                                                    // 60
    var apiTokenOwner = {                                                                                             // 61
      clientPowerboxRequest: {                                                                                        // 62
        grainId: grainId,                                                                                             // 63
        sessionId: session._id                                                                                        // 64
      }                                                                                                               // 62
    };                                                                                                                // 61
    var cap = frontendRefRegistry.create(db, frontendRef, requirements);                                              // 68
    var sturdyRef = waitPromise(cap.save(apiTokenOwner)).sturdyRef.toString();                                        // 69
    cap.close();                                                                                                      // 70
    return {                                                                                                          // 71
      sturdyRef: sturdyRef,                                                                                           // 71
      descriptor: descriptor                                                                                          // 71
    };                                                                                                                // 71
  },                                                                                                                  // 72
  fulfillUiViewRequest: function (sessionId, obsolete1, grainId, petname, roleAssignment, ownerGrainId) {             // 74
    var db = this.connection.sandstormDb;                                                                             // 75
    check(sessionId, String);                                                                                         // 76
    check(grainId, String);                                                                                           // 77
    check(roleAssignment, db.roleAssignmentPattern);                                                                  // 78
    check(petname, String);                                                                                           // 79
    check(ownerGrainId, String);                                                                                      // 80
                                                                                                                      //
    if (!this.userId) {                                                                                               // 82
      throw new Meteor.Error(403, "Must be logged in");                                                               // 83
    }                                                                                                                 // 84
                                                                                                                      //
    var provider = {                                                                                                  // 86
      accountId: this.userId                                                                                          // 87
    };                                                                                                                // 86
    var title = db.userGrainTitle(grainId, this.userId);                                                              // 90
    var descriptor = encodePowerboxDescriptor({                                                                       // 92
      tags: [{                                                                                                        // 93
        id: Grain.UiView.typeId,                                                                                      // 94
        value: Capnp.serialize(Grain.UiView.PowerboxTag, {                                                            // 95
          title: title                                                                                                // 95
        })                                                                                                            // 95
      }]                                                                                                              // 94
    });                                                                                                               // 92
    var owner = {                                                                                                     // 100
      clientPowerboxRequest: {                                                                                        // 101
        grainId: ownerGrainId,                                                                                        // 102
        sessionId: sessionId                                                                                          // 103
      }                                                                                                               // 101
    };                                                                                                                // 100
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);       // 107
    return {                                                                                                          // 110
      sturdyRef: result.token,                                                                                        // 111
      descriptor: descriptor                                                                                          // 112
    };                                                                                                                // 110
  }                                                                                                                   // 114
});                                                                                                                   // 41
                                                                                                                      //
var PowerboxOption = function () {                                                                                    //
  function PowerboxOption(fields) {                                                                                   // 118
    (0, _classCallCheck3.default)(this, PowerboxOption);                                                              // 118
                                                                                                                      //
    _.extend(this, fields);                                                                                           // 119
  }                                                                                                                   // 120
                                                                                                                      //
  PowerboxOption.prototype.intersect = function () {                                                                  //
    function intersect(other) {                                                                                       //
      // Intersect two options with the same ID. Used when combining matches from multiple tags                       // 123
      // in the same descriptor. The tags are a conjunction.                                                          // 124
      //                                                                                                              // 125
      // Returns true if there was any overlap, or false if there was no overlap and therefore the                    // 126
      // option should be dropped.                                                                                    // 127
      //                                                                                                              // 128
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 129
      if (other._id != this._id) {                                                                                    // 131
        throw new Error("can only merge options with the same ID");                                                   // 132
      }                                                                                                               // 133
                                                                                                                      //
      if (other.grainId) {                                                                                            // 135
        if (this.uiView && !other.uiView) delete this.uiView;                                                         // 136
        if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                       // 137
        return !!(this.uiView || this.hostedObject);                                                                  // 138
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 139
        // Try to hint which verifierId matched.                                                                      // 140
        if (this.frontendRef.verifiedEmail.verifierId) {                                                              // 141
          if (other.frontendRef.verifiedEmail.verifierId) {                                                           // 142
            // Can't match multiple verifiers at once.                                                                // 143
            return false;                                                                                             // 144
          }                                                                                                           // 145
        } else if (other.frontendRef.verifiedEmail.verifierId) {                                                      // 146
          // One request did not specify any verifierId, the other did, and both matched, so use                      // 147
          // the verifierId.                                                                                          // 148
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 149
        }                                                                                                             // 150
                                                                                                                      //
        return true;                                                                                                  // 152
      } else {                                                                                                        // 153
        // No intersection logic needed for other types.                                                              // 154
        return true;                                                                                                  // 155
      }                                                                                                               // 156
    }                                                                                                                 // 157
                                                                                                                      //
    return intersect;                                                                                                 //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.union = function () {                                                                      //
    function union(other) {                                                                                           //
      // Union two options with the same ID. Used when combining matches from multiple descriptors.                   // 160
      // The descriptors are a disjunction.                                                                           // 161
      //                                                                                                              // 162
      // TODO(cleanup): How do we factor out the type-specific logic through FrontendRefRegistry?                     // 163
      if (other._id != this._id) {                                                                                    // 165
        throw new Error("can only merge options with the same ID");                                                   // 166
      }                                                                                                               // 167
                                                                                                                      //
      if (other.grainId) {                                                                                            // 169
        if (!this.uiView && other.uiView) this.uiView = other.uiView;                                                 // 170
        if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                         // 171
      } else if ((this.frontendRef || {}).verifiedEmail) {                                                            // 172
        // If this doesn't have a verifierId but other does, copy it over.                                            // 173
        if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {               // 174
          this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                     // 176
        }                                                                                                             // 177
      }                                                                                                               // 178
    }                                                                                                                 // 179
                                                                                                                      //
    return union;                                                                                                     //
  }();                                                                                                                //
                                                                                                                      //
  PowerboxOption.prototype.subtract = function () {                                                                   //
    function subtract(other) {                                                                                        //
      // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                     // 182
      // if there's anything left, false otherwise.                                                                   // 183
      if (other._id != this._id) {                                                                                    // 185
        throw new Error("can only merge options with the same ID");                                                   // 186
      }                                                                                                               // 187
                                                                                                                      //
      if (other.grainId) {                                                                                            // 189
        if (this.uiView && other.uiView) delete this.uiView;                                                          // 190
        if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                        // 191
        return !!(this.uiView || this.hostedObject);                                                                  // 192
      } else {                                                                                                        // 193
        return false;                                                                                                 // 194
      }                                                                                                               // 195
    }                                                                                                                 // 196
                                                                                                                      //
    return subtract;                                                                                                  //
  }();                                                                                                                //
                                                                                                                      //
  return PowerboxOption;                                                                                              //
}();                                                                                                                  //
                                                                                                                      //
function registerUiViewQueryHandler(frontendRefRegistry) {                                                            // 199
  // TODO(cleanup): Maybe this belongs in a different file? But where?                                                // 200
  frontendRefRegistry.register({                                                                                      // 202
    typeId: Grain.UiView.typeId,                                                                                      // 203
    query: function (db, userId, value) {                                                                             // 205
      if (!userId) return []; // TODO(someday): Allow `value` to specify app IDs to filter for.                       // 206
                                                                                                                      //
      var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                            // 210
        return token.grainId;                                                                                         // 210
      });                                                                                                             // 210
      var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                                // 211
        return grain._id;                                                                                             // 211
      });                                                                                                             // 211
      return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                    // 213
        return new PowerboxOption({                                                                                   // 214
          _id: "grain-" + grainId,                                                                                    // 215
          grainId: grainId,                                                                                           // 216
          uiView: {},                                                                                                 // 217
          cardTemplate: "grainPowerboxCard",                                                                          // 218
          configureTemplate: "uiViewPowerboxConfiguration"                                                            // 219
        });                                                                                                           // 214
      });                                                                                                             // 221
    }                                                                                                                 // 222
  });                                                                                                                 // 202
}                                                                                                                     // 224
                                                                                                                      //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                              // 226
  var _this = this;                                                                                                   // 226
                                                                                                                      //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                             // 227
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                           // 228
  // packed format and base64-encoded. The publish populates a pseudo-collection called                               // 229
  // `powerboxOptions`. Each item has the following fields:                                                           // 230
  //                                                                                                                  // 231
  //   _id: Unique identifier string.                                                                                 // 232
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"                    // 233
  //        and is only guaranteed to be unique because we currently don't allow a client to have                     // 234
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness                  // 235
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`               // 236
  //        to be either a string or an `ObjectID`.                                                                   // 237
  //   requestId: The value of `requestId` that was passed in when subscribing.                                       // 238
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                            // 239
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                        // 240
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                      // 241
  //       of the field is the same as ApiTokens.frontendRef.                                                         // 242
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                        // 243
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                        // 244
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user                     // 245
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an                     // 246
  //       object with the fields:                                                                                    // 247
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user                     // 248
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                      // 249
  //         permissions when requesting a plain UiView.                                                              // 250
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                      // 251
  //       match the query. If selected, a request session to the grain embedded should be shown                      // 252
  //       embedded in the powerbox and the same request should be passed to it. Only present when                    // 253
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.                     // 254
  //   cardTemplate: Names the client-side template to use to display this powerbox option. The                       // 255
  //       template's data context will be a "card" object as returned by                                             // 256
  //       SandstormPowerboxRequest.filteredCardData(). Also, the template definition (in client                      // 257
  //       code) may have a static method `powerboxIconSrc` which takes the card as a parameter                       // 258
  //       and returns the URL of the icon to display next to the option.                                             // 259
  //   configureTemplate: If selecting this option should then show a further dialog, names the                       // 260
  //       client-side template for that dialog.                                                                      // 261
  //   ...: Other fields may be added for consumption by the client-side template.                                    // 262
  check(requestId, String);                                                                                           // 264
  check(descriptorList, [String]);                                                                                    // 265
  var results = {};                                                                                                   // 267
  var db = this.connection.sandstormDb;                                                                               // 268
  var frontendRefRegistry = this.connection.frontendRefRegistry;                                                      // 269
                                                                                                                      //
  if (descriptorList.length > 0) {                                                                                    // 271
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                          // 272
      // Decode the descriptor.                                                                                       // 273
      // TODO(now): Also single-segment? Canonical?                                                                   // 274
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                           // 276
      var queryDescriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), {        // 277
        packed: true                                                                                                  // 280
      });                                                                                                             // 280
      if (!queryDescriptor.tags || queryDescriptor.tags.length === 0) return {}; // Expand each tag into a match map.
                                                                                                                      //
      var tagMatches = queryDescriptor.tags.map(function (tag) {                                                      // 285
        var result = {};                                                                                              // 286
        frontendRefRegistry.query(db, _this.userId, tag).forEach(function (option) {                                  // 288
          result[option._id] = new PowerboxOption(option);                                                            // 289
        });                                                                                                           // 290
        return result;                                                                                                // 292
      }); // Intersect two tags' matches.                                                                             // 293
                                                                                                                      //
      var matches = tagMatches.reduce(function (a, b) {                                                               // 296
        for (var id in meteorBabelHelpers.sanitizeForInObject(a)) {                                                   // 297
          if (id in b) {                                                                                              // 298
            if (!a[id].intersect(b[id])) {                                                                            // 299
              // Empty intersection.                                                                                  // 300
              delete a[id];                                                                                           // 301
            }                                                                                                         // 302
          } else {                                                                                                    // 303
            // This match only exists in a, not b, so delete it.                                                      // 304
            delete a[id];                                                                                             // 305
          }                                                                                                           // 306
        }                                                                                                             // 307
                                                                                                                      //
        return a;                                                                                                     // 309
      }); // Search among the user's grains for hosted objects that match.                                            // 310
                                                                                                                      //
      if (_this.userId) {                                                                                             // 314
        var user = Meteor.users.findOne(_this.userId); // Find all grains shared to this user.                        // 315
                                                                                                                      //
        var sharedGrainIds = db.userApiTokens(_this.userId).map(function (token) {                                    // 318
          return token.grainId;                                                                                       // 318
        }); // Among all grains owned by the user or shared with the user, search for grains having                   // 318
        // any powerbox tag IDs matching the tag IDs in the query.                                                    // 321
                                                                                                                      //
        db.collections.grains.find({                                                                                  // 322
          $or: [{                                                                                                     // 324
            userId: _this.userId                                                                                      // 324
          }, {                                                                                                        // 324
            _id: {                                                                                                    // 324
              $in: sharedGrainIds                                                                                     // 324
            }                                                                                                         // 324
          }],                                                                                                         // 324
          "cachedViewInfo.matchRequests.tags.id": {                                                                   // 325
            $in: queryDescriptor.tags.map(function (tag) {                                                            // 326
              return tag.id;                                                                                          // 326
            })                                                                                                        // 326
          }                                                                                                           // 326
        }, {                                                                                                          // 323
          fields: {                                                                                                   // 327
            "cachedViewInfo.matchRequests": 1                                                                         // 327
          }                                                                                                           // 327
        }).forEach(function (grain) {                                                                                 // 327
          // Filter down to grains that actually have a matching descriptor.                                          // 329
          var alreadyMatched = false;                                                                                 // 330
          grain.cachedViewInfo.matchRequests.forEach(function (grainDescriptor) {                                     // 331
            if (alreadyMatched) return; // Build map of descriptor tags by ID.                                        // 332
                                                                                                                      //
            var grainTagsById = {};                                                                                   // 335
            grainDescriptor.tags.forEach(function (tag) {                                                             // 336
              grainTagsById[tag.id] = tag.value;                                                                      // 337
            });                                                                                                       // 338
            var allMatched = true;                                                                                    // 340
            queryDescriptor.tags.forEach(function (queryTag) {                                                        // 341
              if (!allMatched) return;                                                                                // 342
                                                                                                                      //
              if (queryTag.id in grainTagsById) {                                                                     // 344
                var value = grainTagsById[queryTag.id]; // Null values match everything, so only pay attention if non-null.
                                                                                                                      //
                if (value && queryTag.value) {                                                                        // 347
                  if (!Capnp.matchPowerboxQuery(queryTag.value, value)) {                                             // 348
                    allMatched = false;                                                                               // 349
                  }                                                                                                   // 350
                }                                                                                                     // 351
              } else {                                                                                                // 352
                allMatched = false;                                                                                   // 353
              }                                                                                                       // 354
            });                                                                                                       // 355
                                                                                                                      //
            if (allMatched) {                                                                                         // 357
              alreadyMatched = true;                                                                                  // 358
              var option = new PowerboxOption({                                                                       // 359
                _id: "grain-" + grain._id,                                                                            // 360
                grainId: grain._id,                                                                                   // 361
                hostedObject: {},                                                                                     // 362
                cardTemplate: "grainPowerboxCard",                                                                    // 363
                configureTemplate: "uiViewPowerboxConfiguration" // TODO(cleanup): rename                             // 364
                                                                                                                      //
              });                                                                                                     // 359
                                                                                                                      //
              if (option._id in matches) {                                                                            // 366
                matches[option._id].union(option);                                                                    // 367
              } else {                                                                                                // 368
                matches[option._id] = option;                                                                         // 369
              }                                                                                                       // 370
            }                                                                                                         // 371
          });                                                                                                         // 372
        });                                                                                                           // 373
      }                                                                                                               // 374
                                                                                                                      //
      return {                                                                                                        // 376
        descriptor: queryDescriptor,                                                                                  // 376
        matches: matches                                                                                              // 376
      };                                                                                                              // 376
    }); // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're                // 377
    //   supposed to compare descriptors to determine which ones are more specific than which                         // 380
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:                   // 381
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                           // 382
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                        // 383
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                        // 384
    //   list.                                                                                                        // 385
                                                                                                                      //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                          // 387
      if (clause.matchQuality === "unacceptable") {                                                                   // 388
        // Remove b's matches from a.                                                                                 // 389
        for (var id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                      // 390
          if (id in finalMatches) {                                                                                   // 391
            if (!finalMatches[id].subtract(clause.matches[id])) {                                                     // 392
              delete finalMatches[id];                                                                                // 393
            }                                                                                                         // 394
          }                                                                                                           // 395
        }                                                                                                             // 396
                                                                                                                      //
        return finalMatches;                                                                                          // 398
      } else {                                                                                                        // 399
        for (var _id in meteorBabelHelpers.sanitizeForInObject(clause.matches)) {                                     // 400
          if (_id in finalMatches) {                                                                                  // 401
            finalMatches[_id].union(clause.matches[_id]);                                                             // 402
          } else {                                                                                                    // 403
            finalMatches[_id] = clause.matches[_id];                                                                  // 404
          }                                                                                                           // 405
                                                                                                                      //
          if (clause.matchQuality === "preferred") {                                                                  // 407
            finalMatches[_id].matchQuality = "preferred";                                                             // 408
          }                                                                                                           // 409
        }                                                                                                             // 410
                                                                                                                      //
        return finalMatches;                                                                                          // 412
      }                                                                                                               // 413
    }, {});                                                                                                           // 414
                                                                                                                      //
    for (var id in meteorBabelHelpers.sanitizeForInObject(matches)) {                                                 // 416
      if (!matches[id].matchQuality) {                                                                                // 417
        matches[id].matchQuality = "acceptable";                                                                      // 418
      }                                                                                                               // 419
                                                                                                                      //
      matches[id].requestId = requestId;                                                                              // 421
      this.added("powerboxOptions", id, matches[id]);                                                                 // 422
    }                                                                                                                 // 423
  } // TODO(someday): Make reactive? Seems annoying.                                                                  // 424
                                                                                                                      //
                                                                                                                      //
  this.ready();                                                                                                       // 428
});                                                                                                                   // 429
SandstormPowerbox = {                                                                                                 // 431
  registerUiViewQueryHandler: registerUiViewQueryHandler                                                              // 431
};                                                                                                                    // 431
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{
  "extensions": [
    ".js",
    ".json"
  ]
});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerbox: SandstormPowerbox
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
